﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Documents.Excel;
using System.Diagnostics;
using System.IO;
using System.Xml.Serialization;
using Infragistics.Documents.Reports.Report;
using Infragistics.Documents.Reports.Report.Section;
using Infragistics.Documents.Reports.Report.Shapes;
using Infragistics.Win.UltraWinGrid;

namespace WinGridExportingSeveralFormat
{
    public partial class Form1 : Form
    {
        Dictionary<string, string> format = new Dictionary<string, string>();
        string selctedFormat = "Excel2007";
        public DataSet GenerateDataSet()
        {
            DataSet ds = new DataSet();
            XmlSerializer xmlSerializer = new XmlSerializer(typeof(DataSet));
            FileStream readStream = new FileStream("..\\..\\Data\\DatasetNotWorking.xml", FileMode.Open);
            ds = (DataSet)xmlSerializer.Deserialize(readStream);
            readStream.Close();
            return ds;


        }
        public Form1()
        {
            InitializeComponent();
            ultraGrid1.DataSource = GenerateDataSet();
            format.Add("Excel2007", "Excel2007 (*.xlsx)|*.xlsx");
            format.Add("Excel97To2003", "Excel97To2003 (*.xls)|*.xls");
            format.Add("PDF", "PDF (*.pdf)|*.pdf");
            format.Add("XPS", "XPS (*.xps)|*.xps");
            radioButton1.Text = "Excel2007";
            radioButton2.Text = "Excel97To2003";
            radioButton3.Text = "PDF";
            radioButton4.Text = "XPS";
           // ultraGrid1.DisplayLayout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.Horizontal;
        }

        private void ExportToExcel2007(String path)
        {
            Workbook book = new Workbook(   WorkbookFormat.Excel2007);
            ultraGridExcelExporter1.Export(ultraGrid1, book);
            book.Save(path);
        }

        private void ExportToExcel97To2003(String path)
        {
            Workbook book = new Workbook(WorkbookFormat.Excel97To2003);
            ultraGridExcelExporter1.Export(ultraGrid1, book);
            book.Save(path);
        }

        private void ExportToPDF(String path, int ColOnPage)
        {
            Report rep = new Report();
            int currColumn = 0;
            ultraGrid1.BeginUpdate();
            int maxCount = HideAll(ref ultraGrid1);

            while (currColumn < maxCount)
            {
                UnhideInDeep(currColumn, ref ultraGrid1);
                currColumn ++;
                if (currColumn % ColOnPage == 0)
                {
                    ultraGridDocumentExporter1.Export(ultraGrid1,rep);
                    HideAll(ref ultraGrid1);
                }
            }
            UnHideAll(ref ultraGrid1);
            ultraGrid1.EndUpdate();
            rep.Publish(path, FileFormat.PDF);
        }

        private int HideAll(ref UltraGrid grid)
        {
            int maxCount = -1; 
            foreach (var band in grid.DisplayLayout.Bands)
            {
                if (maxCount < band.Columns.Count)
                    maxCount = band.Columns.Count;
                foreach (var col in band.Columns)
                {
                    col.Hidden = true;
                }
            }
            return maxCount;
        }

        private void UnHideAll(ref UltraGrid grid)
        {
            foreach (var band in grid.DisplayLayout.Bands)
            {
                foreach (var col in band.Columns)
                {
                    if(!col.IsChaptered)
                      col.Hidden = false;
                }
            }
        }

        private void UnhideInDeep(int colIndex, ref UltraGrid grid)
        {
            bool ShouldParenHasToHaveVisibleCol = false;
            for (int i = grid.DisplayLayout.Bands.Count - 1; i > -1; i-- )
            {
                UltraGridBand band = grid.DisplayLayout.Bands[i];
                if (band.Columns.Count > colIndex)
                {
                    if (!band.Columns[colIndex].IsChaptered)
                    {
                        band.Columns[colIndex].Hidden = false;
                        ShouldParenHasToHaveVisibleCol = true;
                    }
                }
                else
                {
                    if (ShouldParenHasToHaveVisibleCol)
                        band.Columns[0].Hidden = false;
                }
            }
        }

        private void ExportToXPS(String path)
        {
            ultraGridDocumentExporter1.Export(ultraGrid1, path, Infragistics.Win.UltraWinGrid.DocumentExport.GridExportFileFormat.XPS);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string filename = string.Empty;
            switch (selctedFormat)
            {
                case "Excel2007":
                    filename = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "x.xlsx");
                    ExportToExcel2007(filename);
                    break;
                case "Excel97To2003":
                    filename = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "x.xls");
                    ExportToExcel97To2003(filename);
                    break;
                case "PDF":
                    filename = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "x.pdf");
                    ExportToPDF(filename, 25);
                    break;
                case "XPS":
                    filename = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "x.xps");
                    ExportToXPS(filename);
                    break;
            }
            Process.Start(filename);
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            selctedFormat = ((RadioButton)sender).Text;
        }

        private void ultraGridDocumentExporter1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.DocumentExportInitializeRowEventArgs e)
        {
            
        }

        private void ultraGridDocumentExporter1_CellExporting(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.CellExportingEventArgs e)
        {
            e.ReportCell.Borders = new Borders( new Infragistics.Documents.Reports.Graphics.Pen( Infragistics .Documents .Reports.Graphics .Colors .Blue , Infragistics.Documents.Reports.Graphics.DashStyle.DashDotDot ));
            
        }

        private void ultraGridDocumentExporter1_RowExporting(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.RowExportingEventArgs e)
        {
           
        }

        private void ultraGridDocumentExporter1_BeginExport(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.BeginExportEventArgs e)
        {
            e.Layout.Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.None;
            e.Layout.Override.BorderStyleCell = Infragistics.Win.UIElementBorderStyle.Inset;
        }

        private void ultraGridExcelExporter1_CellExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.CellExportingEventArgs e)
        {
            
        }

        private void ultraGridExcelExporter1_CellExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.CellExportedEventArgs e)
        {
            WorksheetCell cell = e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex];
            cell.CellFormat.FormatString = "0.00";

        }

        private void ultraGridExcelExporter1_BeginExport(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.BeginExportEventArgs e)
        {
            e.Layout.ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand.Horizontal;
        }
    }
}
